/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSMappingModel;

import dstep.coredata.NSManagedObjectModel;
import dstep.foundation.NSArray;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSURL;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSMappingModel : NSObject
{
	mixin (ObjcWrap);

	static NSMappingModel mappingModelFromBundles (NSArray bundles, NSManagedObjectModel sourceModel, NSManagedObjectModel destinationModel)
	{
		return invokeObjcSelfClass!(NSMappingModel, "mappingModelFromBundles:forSourceModel:destinationModel:", NSArray, NSManagedObjectModel, NSManagedObjectModel)(bundles, sourceModel, destinationModel);
	}

	NSMappingModel initWithContentsOfURL (NSURL url)
	{
		id result = invokeObjcSelf!(id, "initWithContentsOfURL:", NSURL)(url);
		return result is this.objcObject ? this : (result !is null ? new NSMappingModel(result) : null);
	}

	this (NSURL url)
	{
		super(NSMappingModel.alloc.initWithContentsOfURL(url).objcObject);
	}

	NSArray entityMappings ()
	{
		return invokeObjcSelf!(NSArray, "entityMappings");
	}

	void setEntityMappings (NSArray mappings)
	{
		return invokeObjcSelf!(void, "setEntityMappings:", NSArray)(mappings);
	}

	NSDictionary entityMappingsByName ()
	{
		return invokeObjcSelf!(NSDictionary, "entityMappingsByName");
	}
}

